//id.cpp
#include <string.h>
#include <stdio.h>
#include "id.h"
#include "config.h"
#include "tdef.h"
//#include "types.h"
#include "vcsocket.h"

DID	mainID;		//мой идентификатор

#if(_mode_server == 0)
//номер сервера для клиента
DID	serverID;	//идентификатор сервера
#endif

//инициализация моей идентификации
void	IDinit(void)
{
	mainID.id_nout	= _main_id_num;
    mainID.id_tout	= _main_id_type;
	mainID.id_nin	= _main_id_num;
	mainID.id_tin	= _main_id_type;
}

//установка (изменение) номера идентификации
void	IDsetNum(u_int16_t num)
{
	mainID.id_nout	= num;
	mainID.id_nin	= num;
}

#if(_mode_server == 1)
//проверка и новый номер идентификации клиенту
//параметры: 	1 - ссылка на буфер приёма
//		2 - ссылка на буфер передачи
//		3 - идентификатор клиента в списке соединений и потоков
u_int32_t	IDNumForClient(u_int8_t * indat, u_int8_t * outdat, int idclient)
{
	u_int8_t	cmd;
	int		cntidc	= 0;	
	//u_int16_t	tin,nin;
	u_int16_t	num 	= 1;	//начальный счёт с единицы для присвоения
	bool		nnew	= false;
	while(cntidc < _max_sock)
	{
		//сравнение с сервером
		if(WServer.dtcp[idclient].id.id_nout == mainID.id_nout)	//номер клиента равен серверу
		{
			num++;	//следующий
			nnew	= true;
		}
		//сравнение с другими клиентами
		if(cntidc != idclient)	//со своим не проверяем
		{
			//поиск совпадения номера идентификации
			if(WServer.dtcp[idclient].id.id_nout == WServer.dtcp[cntidc].id.id_nout)
			{
				num++;
				nnew	= true;
			}
			else
				break;
		}
		cntidc++;
	}
	//
	if(nnew == true)
	{
		#if(_mode_dbg)
			printf("--set client num --\n");
		#endif
		//от кого кому - обратная передача
		//tin	= WServer.dtcp[idclient].id.id_tout;//(*(u_int16_t*)(indat + _id_tout0));
		//nin	= WServer.dtcp[idclient].id.id_nout;//(*(u_int16_t*)(indat + _id_nout0));
		//
		(*(u_int8_t*)(outdat + _idtypecmd))	= _idtypecmd_wrnumc;	//меняем номер клиента
		(*(u_int16_t*)(outdat + _id_tin0))	= WServer.dtcp[idclient].id.id_tout; //tin;
		(*(u_int16_t*)(outdat + _id_nin0))	= WServer.dtcp[idclient].id.id_nout; //nin;
		(*(u_int16_t*)(outdat + _id_tout0))	= mainID.id_tout;
		(*(u_int16_t*)(outdat + _id_nout0))	= mainID.id_nout;
		(*(u_int8_t*)(outdat + _idtype))	= _idtype_ID;		//тип обращения
		(*(u_int16_t*)(outdat + _idnum_wc))	= num;			//передаём новый номер идентификации
		(*(u_int8_t*)(outdat + _cop))		= _cop_wr;		//это запись нового параметра
		(*(u_int16_t*)(outdat + _mtime0))	= tmark;		//маркер времени
		(*(u_int32_t*)(outdat + _tcp_sz0))	= _idnum_wc + 2;	//размер передачи
		//
		return _idnum_wc + 2;
	}
	else
		return 0;
}
#endif

//обработка идентификации
u_int32_t	IDworkIDmain(u_int8_t * indat, u_int8_t * outdat)
{
	u_int8_t	cmd;
	u_int16_t	tin,nin;
	u_int16_t	txsz	= 0;
	//
	cmd	= (*(u_int8_t*)(indat + _idtypecmd));
	tin	= (*(u_int16_t*)(indat + _id_tout0));
	nin	= (*(u_int16_t*)(indat + _id_nout0));
	switch(cmd)
	{
		case _idtypecmd_reads:	//чтение идентификатора сервера
		case _idtypecmd_readc:	//чтение идентификатора клиента
			(*(u_int8_t*)(outdat + _idtypecmd))	= cmd;		//ответ команды
			(*(u_int16_t*)(outdat + _id_tin0))	= tin;
			(*(u_int16_t*)(outdat + _id_nin0))	= nin;
			(*(u_int16_t*)(outdat + _id_tout0))	= mainID.id_tout;
			(*(u_int16_t*)(outdat + _id_nout0))	= mainID.id_nout;
			(*(u_int8_t*)(outdat + _idtype))	= _idtype_ID;	//тип обращения
			(*(u_int8_t*)(outdat + _idcnt))		= 1;		//один идентификатор
			memcpy(outdat + _iddat, &mainID, sizeof(DID));
			(*(u_int8_t*)(outdat + _cop))		= _cop_answer;	//это ответ
			(*(u_int16_t*)(outdat + _mtime0))	= tmark;
			(*(u_int32_t*)(outdat + _tcp_sz0))	= _idcnt + sizeof(DID) + 1;
			txsz	= _idcnt + sizeof(DID) + 1;
			break;
		#if(_mode_server == 0)
		case _idtypecmd_wrnumc:	//запись номера идентификации в клиент
			(*(u_int8_t*)(outdat + _idtypecmd))	= cmd;
			(*(u_int16_t*)(outdat + _id_tin0))	= tin;
			(*(u_int16_t*)(outdat + _id_nin0))	= nin;
			(*(u_int16_t*)(outdat + _id_tout0))	= mainID.id_tout;
			(*(u_int16_t*)(outdat + _id_nout0))	= mainID.id_nout;
			(*(u_int8_t*)(outdat + _idtype))	= _idtype_ID;	//тип обращения
			IDsetNum((*(u_int16_t*)(indat + _idnum_wc)));		//наш новый номер идентификации
			(*(u_int8_t*)(outdat + _cop))		= _cop_answer;	//это ответ
			(*(u_int16_t*)(outdat + _mtime0))	= tmark;
			(*(u_int32_t*)(outdat + _tcp_sz0))	= _idnum_wc + 2;
			txsz	= _idnum_wc + 2;
			break;
		#endif
		default:
			#if(_mode_dbg)
				printf("IDworkIDmain not work cmd=%i\n", cmd);
				printf("resv bytes: ");
				u_int32_t sz		= (*(u_int32_t*)(indat + _tcp_sz0));
				u_int32_t cnts	= 0;
				while(cnts < sz)
				{
					printf("%02X ", (*(u_int8_t*)(indat + cnts)));
					cnts++;
				}
				printf("\n");
			#endif
			break;
	}
	return txsz;
}

//формирование запроса идентификации
void	IDworkIDrequest(u_int8_t * outdat)
{
	(*(u_int32_t*)(outdat + _tcp_sz0)) 	= (u_int32_t)(_idtypecmd + 1);	//размер пакета
	(*(u_int8_t*)(outdat + _idtypecmd))	= _idtypecmd_reads;
	(*(u_int8_t*)(outdat + _idtype))	= _idtype_ID;
}

#if(_mode_server == 0)
//обработка ответа на запрос
void	IDworkIDanswer(u_int8_t * indat)
{
	switch((*(u_int8_t*)(indat + _idtypecmd)))
	{
		case _idtypecmd_reads:	//идентификатор сервера
			memcpy(&serverID, indat + _iddat, sizeof(DID));
			break;
		default:
			#if(_mode_dbg)
				printf("IDworkIDanswer not work\n");
				printf("resv bytes: ");
				u_int32_t sz		= (*(u_int32_t*)(indat + _tcp_sz0));
				u_int32_t cnts	= 0;
				while(cnts < sz)
				{
					printf("%02X ", (*(u_int8_t*)(indat + cnts)));
					cnts++;
				}
				printf("\n");
			#endif
			break;
	}
}
#endif

/*
*************************************
внешние запросы
*************************************
*/
#if(_mode_server == 0)
u_int16_t ReadIDTserver(void)
{
	u_int16_t res;
	pthread_mutex_lock(&ClientMutex);
	res	= serverID.id_tout;
	pthread_mutex_unlock(&ClientMutex);
	return res;
}
#endif

#if(_mode_server == 0)
u_int16_t ReadIDNserver(void)
{
	u_int16_t res;
	pthread_mutex_lock(&ClientMutex);
	res	= serverID.id_nout;
	pthread_mutex_unlock(&ClientMutex);
	return res;
}
#endif

