#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "config.h"
#include "vcsocket.h"
#include "id.h"
#include "wcam.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    //
    int cnt1, cnt2;
    //
    IDinit();
    cnt1 = 0;
    while(cnt1 < 480)
    {
        cnt2 = 0;
        while(cnt2 < 640)
        {
            lay0[cnt2][cnt1] = 0;
            cnt2++;
        }
        cnt1++;
    }
    //
    scene               = new QGraphicsScene();
    pix                 = new QPixmap(640,480);
    paint               = new QPainter(pix);
    paint->setWindow(0,0,640,480);
    //
    ui->gView->setHorizontalScrollBarPolicy( Qt::ScrollBarAlwaysOff );
    ui->gView->setVerticalScrollBarPolicy( Qt::ScrollBarAlwaysOff );
    ui->gView->setScene(scene);
    scene->addPixmap(*pix);
    //
    ui->IP_lineEdit->setText(_ipaddr);
    ui->P_lineEdit->setText(_ipport);

    //
    Tmark       =   0;
    connected   =   false;
    //
    tmr = new QTimer(this); // Создаем объект класса QTimer и передаем адрес переменной
    tmr->setInterval(500); // Задаем интервал таймера
    connect(tmr, SIGNAL(timeout()), this, SLOT(Vals())); // Подключаем сигнал таймера к нашему слоту
    tmr->start(500);//tmr->start(0); // Запускаем таймер
}

MainWindow::~MainWindow()
{
    delete ui;
}

//вывод слоя0 в окно
void MainWindow::Layer0(void)
{
    int x,y;
    y = 0;
    while(y < 480)
    {
        x = 0;
        while(x < 640)
        {
            paint->setPen(QColor((lay0[x][y]),0,0));
            paint->drawPoint(x,y);
            x++;
        }
        y++;
    }
}
void MainWindow::paintEvent(QPaintEvent *event)
{
    int infmode;
    //
    scene->clear();
    //
    Layer0();
    //
    if(!(connected))
    {
        paint->setPen(QColor(255,255,255));
        paint->drawText(_pconnx,_pconny,"NOT CONNECTED");
    }
    //
    infmode = ui->comboBox->currentIndex();
    switch(infmode)
    {
        case 0:
            paint->setPen(QColor(255,255,255));
            paint->drawText(_pinfox,_pinfoy,"***** MAIN CONFIG *****");
            paint->drawText(_pinfox,_pinfoy + 15,"MAIN ID NUMBER :\t" + QString::number(mainID.id_nout));
            if(mainID.id_tout & _cfg_server)
                paint->drawText(_pinfox,_pinfoy + 30,"Mode Server");
            else
                paint->drawText(_pinfox,_pinfoy + 30,"Mode Client");
            if(mainID.id_tout & _cfg_sens)
                paint->drawText(_pinfox,_pinfoy + 45,"Mode Sensor");
            else
                paint->drawText(_pinfox,_pinfoy + 45,"Mode No Sensor");
            if(mainID.id_tout & _cfg_mcntrl)
                paint->drawText(_pinfox,_pinfoy + 60,"Mode Dev Control");
            else
                paint->drawText(_pinfox,_pinfoy + 60,"Mode No Dev Control");
            if(mainID.id_tout & _cfg_video)
                paint->drawText(_pinfox,_pinfoy + 75,"Mode Video Data");
            else
                paint->drawText(_pinfox,_pinfoy + 75,"Mode No Video Data");
            if(mainID.id_tout & _cfg_space)
                paint->drawText(_pinfox,_pinfoy + 90,"Mode Space Map Data");
            else
                paint->drawText(_pinfox,_pinfoy + 90,"Mode No Space Map Data");
            if(mainID.id_tout & _cfg_neuro)
                paint->drawText(_pinfox,_pinfoy + 105,"Mode NeuroMatrix Data");
            else
                paint->drawText(_pinfox,_pinfoy + 105,"Mode No NeuroMatrix Data");
            if(mainID.id_tout & _cfg_move_cam)
                paint->drawText(_pinfox,_pinfoy + 120,"Mode Cam Position Control");
            else
                paint->drawText(_pinfox,_pinfoy + 120,"Mode No Cam Position Control");
            if(mainID.id_tout & _cfg_OpenCV)
                paint->drawText(_pinfox,_pinfoy + 135,"Mode Use OpenCV Lib");
            else
                paint->drawText(_pinfox,_pinfoy + 135,"Mode No Use OpenCV Lib");
            if(mainID.id_tout & _cfg_motors)
                paint->drawText(_pinfox,_pinfoy + 150,"Mode Motors Control");
            else
                paint->drawText(_pinfox,_pinfoy + 150,"Mode No Motors Control");

            break;
        case 1:
            paint->setPen(QColor(255,255,255));
            paint->drawText(_pinfox,_pinfoy,"***** SERVER CONFIG *****");
            if(!(connected))
                paint->drawText(_pconnx,_pinfoy,"NOT CONNECTED");
            else
            {
                paint->drawText(_pinfox,_pinfoy + 15,"SERVER ID NUMBER :\t" + QString::number(ReadIDNserver()));
                u_int16_t tid = ReadIDTserver();
                if(tid & _cfg_server)
                    paint->drawText(_pinfox,_pinfoy + 30,"Mode Server");
                else
                    paint->drawText(_pinfox,_pinfoy + 30,"Mode Client");
                if(tid & _cfg_sens)
                    paint->drawText(_pinfox,_pinfoy + 45,"Mode Sensor");
                else
                    paint->drawText(_pinfox,_pinfoy + 45,"Mode No Sensor");
                if(tid & _cfg_mcntrl)
                    paint->drawText(_pinfox,_pinfoy + 60,"Mode Dev Control");
                else
                    paint->drawText(_pinfox,_pinfoy + 60,"Mode No Dev Control");
                if(tid & _cfg_video)
                    paint->drawText(_pinfox,_pinfoy + 75,"Mode Video Data");
                else
                    paint->drawText(_pinfox,_pinfoy + 75,"Mode No Video Data");
                if(tid & _cfg_space)
                    paint->drawText(_pinfox,_pinfoy + 90,"Mode Space Map Data");
                else
                    paint->drawText(_pinfox,_pinfoy + 90,"Mode No Space Map Data");
                if(tid & _cfg_neuro)
                    paint->drawText(_pinfox,_pinfoy + 105,"Mode NeuroMatrix Data");
                else
                    paint->drawText(_pinfox,_pinfoy + 105,"Mode No NeuroMatrix Data");
                if(tid & _cfg_move_cam)
                    paint->drawText(_pinfox,_pinfoy + 120,"Mode Cam Position Control");
                else
                    paint->drawText(_pinfox,_pinfoy + 120,"Mode No Cam Position Control");
                if(tid & _cfg_OpenCV)
                    paint->drawText(_pinfox,_pinfoy + 135,"Mode Use OpenCV Lib");
                else
                    paint->drawText(_pinfox,_pinfoy + 135,"Mode No Use OpenCV Lib");
                if(tid & _cfg_motors)
                    paint->drawText(_pinfox,_pinfoy + 150,"Mode Motors Control");
                else
                    paint->drawText(_pinfox,_pinfoy + 150,"Mode No Motors Control");
            }
            break;
        case 2:
            paint->setPen(QColor(255,255,255));
            paint->drawText(_pinfox,_pinfoy,"***** SERVER ID MAP *****");
            if(!(connected))
                paint->drawText(_pconnx,_pinfoy,"NOT CONNECTED");
            break;
        default:
            break;
    }

    //
    scene->addPixmap(*pix);
}

//соединить-разьединить
void MainWindow::on_pushButton_clicked()
{
    QString stripaddr   = ui->IP_lineEdit->text();
    QString stripport   = ui->P_lineEdit->text();
    char * strip;
    char * strport;
    int port;
    int res;
    QByteArray arip, arport;
    //
    if(connected)
    {
        res     = ClientStop();
        connected   = false;
    }
    else
    {
        arip    = stripaddr.toAscii().data();
        arport  = stripport.toAscii().data();
        strip   = arip.data();
        strport = arport.data();
        port    = atoi(strport);
        res     = ClientStart(&strip[0], port);
        if(res == 0)
            connected = true;
    }
}

void MainWindow::Vals(void)
{
    int res;
    //
    if(Tmark < 0x0FFF)
        Tmark++;
    else
        Tmark = 0;
    //контроль соединения
    res = StatConnect();
    if( res > 0)
        connected = true;
    else
        connected = false;
    if(connected)
    {
        ui->pushButton->setText("Disconnect");
        ui->lTmark->setText(QString::number(ReadTmark()));
        //
        ReadVideo(&lay0[0][0], 0);
    }
    else
    {
        ui->pushButton->setText("Connect");
        ui->lTmark->setText(QString::number(Tmark));
    }
}
